import { isEmpty } from 'lodash';
import { registerMicroApps } from './qiankun/apis';
/**
 *@readonly do not update directly use setAppsObject() in stead
 */
let appsObject;
export function getASMAAppsObject() {
    return appsObject;
}
export function setAppsObject(appsObject) {
    appsObject = appsObject;
}
export async function registerASMAMicroApps(render, apps_object = {}, devtools = false) {
    var _a;
    const loader = (loading) => render({ loading });
    const apps_arr = (_a = Object.values(apps_object).map((mf) => ({ ...mf, loader }))) !== null && _a !== void 0 ? _a : [];
    if (devtools) {
        // eslint-disable-next-line @typescript-eslint/ban-ts-comment
        //@ts-ignore
        const _ = await import('qiankun-overrides');
        // eslint-disable-next-line @typescript-eslint/ban-ts-comment
        //@ts-ignore
        const imo = window.importMapOverrides;
        imo === null || imo === void 0 ? void 0 : imo.setDefaultMap(apps_arr);
        appsObject = imo === null || imo === void 0 ? void 0 : imo.getCurrentQiankunMap();
    }
    if (appsObject && !isEmpty(appsObject)) {
        registerMicroApps(Object.values(appsObject).filter((app) => app.activeRule !== 'component-only'), {
            beforeLoad: async (app) => {
                console.log('[LifeCycle] before load', 'color: green;', app.name);
            },
            beforeMount: async (app) => {
                console.log('[LifeCycle] before mount', 'color: green;', app.name);
            },
            afterUnmount: async (app) => {
                console.log('[LifeCycle] after unmount', 'color: green;', app.name);
            },
        });
    }
}
//# sourceMappingURL=registerASMAMicroApps.js.map